Drew Turketo
Drew Turketo

Reputation: 33

Autocad Error "error: bad arguement type: lselsetp nil" when selecting polyline

I am currently attempting to run a polyline between two blocks (first_block, second_block) that runs along another polyline, at the end of the action an insert function is called that populates an annotation block (cable_name_tag) with the details of the start and end block.

This polyline will transect other blocks and often needs to run in paralell with an underlying polyline (cable_ducting) so the user will need to option to select an appropriate part of the polyline to drop the annotation, as space is sometimes limited.

I have noted that if I comment out the second_block and provide a harcoded value the ssget function works without issue, so I am reasonably sure the issue is with either the syntax or the handling of the first_block and second_block in that code.

(defun c:cable ()
  (vl-load-com)
  (setvar "clayer" "cable layer")
  (setvar "celtype" "bylayer")
  (setvar "osmode" 515)
  (command "_.pline"
           (getpoint))
  (while (> (getvar ' cmdactive) 0)
    (command pause)
    (princ "\npress enter to finish:"))
  (setq elst
        (entsel "\nselect cable segment: "))
  (setq ename
        (car elst))
  (setq pt
        (cadr elst))
  (setq annopt pt)
  (setq pt
        (vlax-curve-getclosestpointto ename pt))
  (setq param
        (vlax-curve-getparamatpoint ename pt))
  (setq preparam
        (fix param))
  (setq postparam
        (1+ preparam))
  (list (setq pt1
              (vlax-curve-getpointatparam ename preparam))
        (setq pt2
              (vlax-curve-getpointatparam ename postparam)))
  (setq cable
        (entlast))
  (setq cable_start
        (vlax-curve-getstartparam cable))
  (setq cable_start_point
        (vlax-curve-getstartpoint cable))
  (setq cable_end_point
        (vlax-curve-getendpoint cable))
  (setq cable_end
        (angtos (angle '(0 0)
                       (vlax-curve-getfirstderiv cable 0.0))))
  (setq first_block
        (ssget "_c" cable_start_point cable_end_point
               (list (cons 0 "insert")
                     (cons 2 "first_block"))))
  (setq second_block
        (ssget "_c" cable_start_point cable_end_point
               (list (cons 0 "insert")
                     (cons 2 "second_block"))))
  (setq end_cable
        (ssname second_block 0))
  (setq start_cable
        (ssname first_block 0))
  (setq $end_cable
        (vla-get-textstring
         (cadr (vlax-safearray->list
                (variant-value
                 (vla-getattributes
                  (vlax-ename->vla-object end_cable)))))))
  (setq $start_cable
        (vla-get-textstring
         (cadr (vlax-safearray->list
                (variant-value
                 (vla-getattributes
                  (vlax-ename->vla-object start_cable)))))))
  (setq cable_name
        (vlax-curve-getendparam cable))
  (command ; insert cable param
           "-insert"
           "cable_name_tag"
           annopt
           "1"
           "1"
           cable_angle
           cable_name
           $start_cable
           $end_cable
           "144"
           cable_length))

I am stuck in a corner on this one, and would appreciate any help, advice or pointers anyone can offer.

Thank you all for your time.

Upvotes: 1

Views: 2616

Answers (1)

Origin
Origin

Reputation: 2023

Why not just use (entlast) to get the entity that was just created?

Upvotes: 1

Related Questions